/***************************************************************************/
/* SUDOKU: DECLARATIONS DE TYPES                                           */
/***************************************************************************/

#ifndef _SUDOKU_H_
#define _SUDOKU_H_

//===========================================================================
// Types et structures
//===========================================================================

// ------------------ Types propres au jeu ----------------------------------
// Nommage:
//  _t    : suffixe pour tous les types
//  JEU_  : prfixe soulignant l'aspect spcifique au jeu
//  _priv_: type 'priv' non-utilis par des routines externes au jeu.
//  i : index
//  a : tableau
//  n : valeur
//  e : etat

//Explications au choix de tel ou tel coup
typedef enum {
  E_JEU_BALAIE_CARRE,   //Coups trouvs par balayage
  E_JEU_BALAIE_LIGNE,
  E_JEU_BALAIE_COLONNE,
  E_JEU_UN_COUP_LEGAL,  //Case avec un seul coup lgal
  E_JEU_CASE_SANS_COUP, //Case sans un seul coup lgal
  E_JEU_ELIM_CARRE,     //Elimination par ensemble
  E_JEU_ELIM_LIGNE,
  E_JEU_ELIM_COLONNE,
  E_JEU_TATONNEMENT,    //Pas de case limite  un coup: on doit ttonner
  E_JEU_ZERO_COUP,      //Pas un seul coup trouv dans toute la grille
  E_JEU_UNDEFINED       //Pas de cause prcise (ex: aprs initialisation)
} JEU_explain_t;

//Position, avant tout traitement algorithmique
typedef struct
{
  int Boardsize; //=Elemsize
  int Elemsize;  //Ct d'une rgion carre de la grille
  unsigned char **cases;  //cases[x][y] contient 0 si la case est vide
}
JEU_position_t;

//Type d'un coup
typedef enum {
  E_JEU_PRIV_COUP_CATEGORY_WRITE, //Ecrire un nombre dans une case
  E_JEU_PRIV_COUP_CATEGORY_CUT    //Raccourcir la liste des valeurs jouables
} JEU_priv_coup_category_t;

//Description d'un coup
typedef struct
{
  JEU_priv_coup_category_t t; //Type de coup
  union
  {
    //E_JEU_PRIV_COUP_CATEGOY_WRITE
    struct {
      int x, y; // Cordonnes de la case
      int n;    // Valeur crite
    } s_write;
    //E_JEU_PRIV_COUP_CATEGOY_CUT
    struct {
      int i_set;      //Index de l'ensemble parent
      char *a_subset; //[]=1 pour les lments prsents
      char *a_vals;   //[]!=0 pour les valeurs prsentes
    } s_cut;
  };
}
JEU_coup_t;

#endif

// ===== FIN DE FICHIER =====
