/***************************************************************************/
/* SUDOKU: DECLARATION DES FONCTIONS                                       */
/***************************************************************************/

#ifndef _SUDOKU_FUNCS_H_
#define _SUDOKU_FUNCS_H_

// ==========================================================================
// Prototypes
// ==========================================================================

// ----- JEU: jouer/manipuler les coups. -----
void JEU_f_jouer(JEU_coup_t *pc);       // Joue ce coup
void JEU_f_annuler(JEU_coup_t *pc);     // Revient en arrire sur ce coup.
void JEU_f_clear_coup(JEU_coup_t *pc);  // intendance: libre la mmoire utilise pour la description d'un coup.

// ----- JEU: fonctions principales appeles par l'algorithme -----
bool_t JEU_f_init(JEU_position_t *p_position);    // A appeler en premier, ou aprs JEU_f_reset()
bool_t JEU_f_lister_coups(ALG_list_coups_t *pL);  // Slectionne des coups intressants  examiner
bool_t JEU_f_est_solution(void);                  // Renvoie TRUE si on a atteint une solution.
//int JEU_f_get_explore_size(void);                 // Nombre maximal d'tapes d'exploration.
void JEU_f_reset(void);                           // Libre toute la mmoire du module 'JEU'

// ----- JEU: explications ------
void JEU_f_init_explain(JEU_explain_t *pe); //Explication par dfaut.
JEU_position_t *JEU_f_get_position(void);
void JEU_f_print_expliquer(int idx, JEU_explain_t *pe, JEU_coup_t *pc); //Explique les raisons d'un coup.

// ----- JEU: dbogage -----
void JEU_f_priv_print_board_n(int v);
void JEU_f_print_board(void);
void JEU_f_print_list(int x, int y);
void JEU_f_print_board_n(int v);

#endif

// ===== FIN DE FICHIER =====
