// =======================================
// Routines de debug gnralistes commodes
// =======================================

// ===== Includes =====

// ----- Librairies standard -----
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

// ----- Sources du projet -------

#include "debug.h"
#include "valid.h"

// ===== Macros Locales =====

// ===== Types locaux =====

// ===== Prototypes des fonctions locales =====

// ===== Fonctions publiques =====

void f_valid_multialloc(void)
{
  int *a_dim1;
  int **a_dim2;
  int ****a_dim4;

  //Allocation/Libration pour une seule dimension.
  m_dbg_start_alloc_count();
  a_dim1 = (int*) f_dbg_mult_alloc(1, sizeof(int), 5); //Tableau  'dim' dimensions, lments de taille 'es', <dimensions>
  f_dbg_mult_free(a_dim1, 1, 5);                       //Librer le tableau.
  m_dbg_end_alloc_count();
  m_dbg_print_counters();

  //Allocation/Libration pour deux dimensions.
  m_dbg_start_alloc_count();
  a_dim2 = (int**) f_dbg_mult_alloc(2, sizeof(int), 5,6); //Tableau  'dim' dimensions, lments de taille 'es', <dimensions>
  f_dbg_mult_free(a_dim2, 2, 5, 6);                      //Librer le tableau.
  a_dim2 = m_dbg_malloc2(int, 5,6); //Idem avec les macros
  m_dbg_mfree2(a_dim2, 5, 6);
  m_dbg_end_alloc_count(); //Compter les points
  m_dbg_print_counters();

  //Allocation/Libration pour quatre dimensions.
  m_dbg_start_alloc_count();
  a_dim4 = (int****) f_dbg_mult_alloc(4, sizeof(int), 5,6,7,8); //Tableau  'dim' dimensions, lments de taille 'es', <dimensions>
  f_dbg_mult_free(a_dim4, 4, 5, 6, 7, 8);                       //Librer le tableau.
  a_dim4 = m_dbg_malloc4(int, 5, 6, 7, 8); //Idem avec les macros
  m_dbg_mfree4(a_dim4, 5, 6, 7, 8);

  m_dbg_end_alloc_count();
  m_dbg_print_counters();
}

// ===== FIN DE FICHIER =====